
; #########################################################################
.NOLIST
    .386
    .model flat, stdcall
    option casemap :none         ; case sensitive
    include \masm32\include\windows.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\masm32.inc

    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\masm32.lib

InStrg          PROTO :DWORD,:DWORD,:DWORD,:DWORD
lstrlenCrZ      PROTO :DWORD,:DWORD
InStrLimited    PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD


.data
position    dd  0
CPT         dd  0

search      db  "woop", 0
titre       db  "How many strings woop in this phrase?", 0
titre1      db  "in text mode InStrg finds the number of woop", 0
titre2      db  "in binary mode InStrg finds the number of woop", 0
titre3      db  "in text mode InStrLimited finds the number of words woop", 0
titre4      db  "in binary mode InStrLimited finds the number of words woop", 0

chaine      db  "Phrase where the search is made search for woop, Boopi awOopi aa:woopa woop.head <woop> Woop", 13, 10
            db  "This is another phrase that couldn't be searched woop woop ", 13, 10, 0

LimitLeft   db  " ",9,"<",0
LimitRight  db  " ",9,">",0

chiffre     db  20 dup (0)
.code

start:
    invoke  MessageBox, NULL, addr chaine, addr titre, MB_OK
    ; begin the search for the number of woop
    mov position,1 ;base 1, first character
    mov     CPT, 0
    @@:
    invoke  InStrg, position, addr chaine, addr search,1    ; text search
    .if eax != 0
      inc     CPT
      mov     position, eax
      ; go after the woop found
      add     position, sizeof search -1    ; don't count the zero
      jmp     @B
    .endif
    invoke  dwtoa, CPT, addr chiffre
    invoke  MessageBox, NULL, addr chiffre, addr titre1, MB_OK
    ;-------------- InStrg binary search
    mov     position, 1         ; base 1,first character
    mov     CPT,0
    @@:
    invoke  InStrg, position, addr chaine, addr search, 0   ; binary search
    .if eax != 0
      inc     CPT
      mov     position, eax
      ; go after the woop found
      add     position, sizeof search -1    ; don't count the zero
      jmp     @B
    .endif
    invoke  dwtoa, CPT, addr chiffre
    invoke  MessageBox, NULL, addr chiffre, addr titre2, MB_OK
    ;------------------------------------------------------------
    ;------------------------------------------------------------
    ; this function is dedicated to find words and not strings

    mov     position, 1         ; base 1, first character
    mov     CPT, 0
    @@:
    invoke  InStrLimited, position, addr chaine, addr search, 1,\
            addr LimitLeft, addr LimitRight ; text search
    .if eax != 0
      inc     CPT
      mov     position, eax
      ; go after the woop found
      add     position, sizeof search -1    ; don't count the zero
      jmp     @B
    .endif
    invoke  dwtoa, CPT, addr chiffre
    invoke  MessageBox, NULL, addr chiffre, addr titre3, MB_OK
    ;------------------------------------------------------------
    mov     position, 1         ; base 1,first character
    mov     CPT, 0
    @@:
    invoke  InStrLimited, position, addr chaine, addr search, 0,\
            addr LimitLeft, addr LimitRight ; binary search
    .if eax != 0
      inc     CPT
      mov     position, eax
      ; go after the woop found
      add     position,sizeof search -1 ; don't count the zero
      jmp     @B
    .endif
    invoke     dwtoa, CPT, addr chiffre
    invoke     MessageBox, NULL, addr chiffre, addr titre4, MB_OK

    Findeminus:
    invoke     ExitProcess,0
    ;------------------------------------------------------------

InStrg proc Start:DWORD,Contenant:DWORD,Chercher:DWORD,Methode:DWORD
; Works the same as the VB version

    Local   LongCont    :DWORD
    Local   PointCont   :DWORD
    Local   LongCherche :DWORD
    Local   DeplaceMax  :DWORD
    local   retour      :DWORD

    Pushad
    mov     retour, 0   ; Set to failure by default
    mov     eax, Start  ; string pointer
        ;------------ is it possible ? --------------------
    .if eax < 1
        mov     retour, 0
        jmp     FinChercherChaine
    .endif

    invoke  lstrlenCrZ, Contenant, MAX_PATH +1

    .if eax < 1
        mov     retour, 0
        jmp     FinChercherChaine
    .endif
    mov     LongCont, eax

    invoke  lstrlenCrZ, Chercher, MAX_PATH + 1
    .if eax < 1
        mov     retour, 0
        jmp     FinChercherChaine
    .endif
    ; the search string must be <= length of the string searched
    mov     LongCherche, eax
    mov     ecx,LongCont
    cmp     eax, ecx
    jle     ValidData
    mov     retour, 0
    jmp     FinChercherChaine
ValidData:
    ; Performing a search is possible
    mov     eax, Start          ; string pointer
    add     eax, LongCherche
    dec     eax
    .if eax > LongCont
      mov     retour, 0
      jmp     FinChercherChaine
    .endif
    mov     ecx, LongCont
    inc     ecx                 ; if not -1 at exit then 0
    sub     ecx, eax
    mov     DeplaceMax, ecx     ; maximum moves of the search pointer

    ; the data is valid

    cld
    push    Start
    Pop     PointCont
    dec     PointCont
    mov     esi, Contenant
    add     esi, Start
    dec     esi
    dec     esi
    mov     edi, Chercher
ProgresseContenant:
    inc     esi
    inc     PointCont               ; possible position found
    xor     ebx, ebx
    xor     eax, eax
    xor     edx, edx                ; dl byte
ProgresseContenu:
    mov     al, byte ptr [esi+ebx]  ; byte of string to search in
    .if Methode == 1                ; change lowercase to uppercase
      .if eax > 96 && eax < 123
        sub     al, 32
      .endif
    .endif
    mov     dl, byte ptr [edi+ebx]  ; byte of string to search
    .if Methode ==1                 ; change lowercase to uppercase
      .if edx > 96 && edx < 123
        sub     dl, 32
      .endif
    .endif

    inc     ebx
    cmp     al, dl
    jnz     NegatifResult
    cmp     ebx, LongCherche
    jnz     ProgresseContenu        ; continue to compare
    jmp     ChaineTrouve
NegatifResult:
    dec     DeplaceMax              ; decrease the move counter
    jnz     ProgresseContenant
    mov     retour, 0               ; not found
    jmp     FinChercherChaine
ChaineTrouve:
    mov     eax, PointCont          ; found at position
    mov     retour, eax

FinChercherChaine:
    popad
    mov     eax, retour
    ret
InStrg endp
;----------------------------------------------------------------

lstrlenCrZ proc uses edi ecx  Debut:DWORD,Max:DWORD
;   String terminated by 0 (not included in search) or 0Dh result in eax, 0 means failure
    mov     edi, Debut
    mov     ecx, Max
    @@:
    mov al,[edi]
    .if al == 0 || al == 0Dh
        mov     eax, edi
        sub     eax, Debut
        ret
    .endif
    inc     edi
    dec     ecx
    jnz     @B
    ; end of string reached
    xor     eax, eax
    ret
lstrlenCrZ endp

;################################################################

InStrLimited proc Start:DWORD,AdrPerdu:DWORD,AdrChercher:DWORD,Methode:DWORD,\
                  AdrAutoriseAvant:DWORD,AdrAutoriseApres:DWORD

    Local   LongCont    :DWORD
    Local   PointCont   :DWORD
    Local   LongCherche :DWORD
    Local   DeplaceMax  :DWORD
    local   retour      :DWORD
    Local   Position    :DWORD

    Pushad

    mov     retour, 1           ; default to success
    mov     eax, Start
    mov     Position, eax
    ;------------------ verify it is possible -------------------
    .if eax < 1
        mov     retour, 0
        jmp     FindechercherMot
    .endif
    invoke  lstrlenCrZ, AdrPerdu, MAX_PATH +1

    .if eax < 1
      mov     retour, 0
      jmp     FindechercherMot
    .endif
    mov     LongCont, eax
    invoke  lstrlenCrZ, AdrChercher, MAX_PATH + 1
    .if eax < 1
      mov     retour, 0
      jmp     FindechercherMot
    .else
      mov     LongCherche, eax
      mov     ecx, LongCont
      cmp     eax, ecx
      jle     ValidData
      mov     retour, 0
      jmp     FindechercherMot
    .endif

    ; The search string must be <= the length of the string searched
ValidData:
    ;------- check that the string fits in what remains
    mov     eax, Position       ; position with the string
    add     eax, LongCherche    ; length of the searched string
    dec     eax
    .if eax > LongCont
      mov     retour, 0
      jmp     FindechercherMot
    .endif
    mov     ecx, LongCont
    inc     ecx                 ; if not -1 at exit then 0
    sub     ecx, eax
    mov     DeplaceMax, ecx     ; possible number of displacements of the search pointer

    ; the data is valid
    ; InsTxt  Message, " the data is valid", 0
    ; invoke  MessageBox, Hwnd, addr Message, addr titre, MB_YESNO

    cld
    push    Position
    Pop     PointCont
    dec     PointCont
    mov     esi, AdrPerdu
    add     esi, Position
    dec     esi                 ; esi=string pointer + starting position - 1
    dec     esi                 ; move backward one position
    mov     edi, AdrChercher
ProgresseAdrPerdu:
    inc     esi
    inc     PointCont           ; position to find
    xor     ebx, ebx
    xor     eax, eax
    xor     edx, edx            ; dl search byte
ProgresseContenu:
    mov     al, byte ptr [esi+ebx]
    .if Methode == 1        ; in uppercase
      .if eax > 96 && eax < 123
        sub     al, 32
      .endif
    .endif
    mov     dl, byte ptr [edi+ebx]
    .if Methode ==1             ; in uppercase
      .if edx > 96 && edx < 123
        sub     dl, 32
      .endif
    .endif

    inc     ebx
    cmp     al, dl
    jnz     NegatifResult
    cmp     ebx, LongCherche
    jnz     ProgresseContenu    ; continue comparing
    jmp     ChaineTrouve
NegatifResult:
    dec     DeplaceMax          ; move back one position
    jnz     ProgresseAdrPerdu
    mov     retour, 0           ; not found
    jmp     FindechercherMot
ChaineTrouve:
    mov     eax, PointCont      ; found at position
    mov     retour, eax         ; string matches
    mov     Position, eax
    ;-------------- Limits ? ---------------------------------------
    ;------- List of limits must be zero terminated
    ;------------------- left limite -----------------------------------------
    mov     esi, AdrPerdu
    .if Position == 1
      jmp     limiteSup         ; Word is at the start of phrase, accept left limit
    .endif
    add     esi, Position
    sub     esi, 2
    mov     al, [esi]
    mov     edi, AdrAutoriseAvant
    ;---------------------------------------------------------------------------
    ;-------- compare all characters in the list
    mov     dl, [edi]
    .if dl == 0
      jmp     limiteSup         ; There is no left limit, accept the left limit
    .endif
    @@:
    mov     dl, [edi]
    .if al == dl
        jmp     limiteSup       ; identical
    .else
      inc     edi
      mov     dl, [edi]
      .if dl == 0
        mov     eax, LongCherche    ; failed, character not in the list
        add     Position, eax
        jmp     ValidData
      .endif
      jmp     @B
    .endif

    ;------------------------------ Right Limit ---------------------------
    limiteSup:
    mov     eax, Position
    dec     eax
    add     eax, LongCherche
    .if eax >= LongCont         ; > is only to secure,it's =
      jmp     FindechercherMot  ; Word at the end of a phrase,accept right limit
    .endif
    ;--------
    mov     esi, AdrPerdu
    add     esi, Position
    dec     esi
    add     esi, LongCherche
    mov     al, [esi]
    .if al == 0
      ; character right limit is 0, accept
      jmp     FindechercherMot
    .endif
    mov     edi, AdrAutoriseApres
    mov     dl, [edi]
    .if dl == 0
      jmp     FindechercherMot  ; right limit empty, accept
    .endif
    @@:
    mov     dl, [edi]
    .if al == dl
      jmp     FindechercherMot  ; strings match
    .else
      inc     edi
      mov     dl, [edi]
      .if dl == 0
        mov     eax, LongCherche    ; failed, character not in the list
        add     Position, eax
        jmp     ValidData
      .endif
       jmp     @B
    .endif

FindechercherMot:
    popad
    mov     eax, retour
    ret

InStrLimited endp

end start

